'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var Tick = require('./Tick.js');
var AxisLine = require('./AxisLine.js');
var _ = require('underscore');
var imUtils = require('../core/im-utils.js');

/*
	{
		axisLine: AxisLine,
		ticks: [Tick]
	}
*/

var Axe = function (_React$Component) {
	_inherits(Axe, _React$Component);

	function Axe() {
		_classCallCheck(this, Axe);

		return _possibleConstructorReturn(this, (Axe.__proto__ || Object.getPrototypeOf(Axe)).apply(this, arguments));
	}

	_createClass(Axe, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(props) {
			return !imUtils.isEqual(props.state, this.props.state);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    state = _props.state,
			    className = _props.className,
			    css = _props.css;


			var axisName = className + 'Line';
			var tickName = className + 'Tick';

			return React.createElement(
				'g',
				null,
				_.map(state.ticks, function (tick) {
					return React.createElement(Tick, { className: tickName, css: css, key: tick.key, state: tick });
				}),
				React.createElement(AxisLine, { className: axisName, css: css, state: state.axisLine })
			);
		}
	}]);

	return Axe;
}(React.Component);

module.exports = Axe;