'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var Label = require('./Label.js');

var sp = require('../core/space-transf.js');
var imUtils = require('../core/im-utils.js');

/*
	{
		// long thin grey line
		grid: {
			show: true || false,
			color: '',
			length: ,
			width: 
		},

	// tick
		tick: {
			show: true || false,
			color: '',
			position: {x, y},
			ds: {x, y},
			length: ,
			dir: {x, y},
			width: ,
			out:
		},

	// tick label
		label: Label
	}
*/

var Tick = function (_React$Component) {
	_inherits(Tick, _React$Component);

	function Tick() {
		_classCallCheck(this, Tick);

		return _possibleConstructorReturn(this, (Tick.__proto__ || Object.getPrototypeOf(Tick)).apply(this, arguments));
	}

	_createClass(Tick, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(props) {
			return !imUtils.isEqual(props.state, this.props.state);
		}

		// grid

	}, {
		key: 'grid',
		value: function grid() {

			var gprops = this.props.state.grid;

			if (gprops.show === false) {
				return null;
			}

			var start = {
				x: sp.toC(this.props.state.tick.ds.x, this.props.state.tick.position.x),
				y: sp.toC(this.props.state.tick.ds.y, this.props.state.tick.position.y)
			};

			var end = {
				x: start.x + this.props.state.tick.dir.x * sp.toCwidth(this.props.state.tick.ds.x, gprops.length),
				y: start.y - this.props.state.tick.dir.y * sp.toCwidth(this.props.state.tick.ds.y, gprops.length)
			};

			var gridName = this.props.className + 'Grid';
			var tickProps = this.props.css ? null : {
				stroke: gprops.color,
				strokeWidth: gprops.width
			};

			return React.createElement('line', _extends({ className: gridName, x1: start.x, x2: end.x, y1: start.y, y2: end.y }, tickProps));
		}
	}, {
		key: 'tick',
		value: function tick() {

			var tprops = this.props.state.tick;

			if (tprops.show === false) {
				return null;
			}

			var x1 = sp.toC(tprops.ds.x, tprops.position.x) - tprops.dir.x * tprops.length * tprops.out;
			var y1 = sp.toC(tprops.ds.y, tprops.position.y) + tprops.dir.y * tprops.length * tprops.out; // beware about y sign!!
			var x2 = x1 + tprops.dir.x * tprops.length;
			var y2 = y1 - tprops.dir.y * tprops.length; // beware about y sign!!

			var linePar = this.props.css ? null : {
				stroke: tprops.color,
				strokeWidth: tprops.width
			};

			return React.createElement('line', _extends({ className: this.props.className, x1: x1, x2: x2, y1: y1, y2: y2 }, linePar));
		}
	}, {
		key: 'label',
		value: function label() {
			if (this.props.state.label.show === false) {
				return null;
			}
			var labelName = this.props.className + 'Label';
			return React.createElement(Label, { className: labelName, css: this.props.css, state: this.props.state.label });
		}
	}, {
		key: 'noShow',
		value: function noShow() {
			return !(this.props.state.tick.show || this.props.state.grid.show || this.props.state.label.show);
		}
	}, {
		key: 'render',
		value: function render() {

			return this.noShow() ? null : React.createElement(
				'g',
				null,
				this.grid(),
				this.tick(),
				this.label()
			);
		}
	}]);

	return Tick;
}(React.Component);

module.exports = Tick;