'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var imUtils = require('../core/im-utils.js');

var Pie = function (_React$Component) {
	_inherits(Pie, _React$Component);

	function Pie() {
		_classCallCheck(this, Pie);

		return _possibleConstructorReturn(this, (Pie.__proto__ || Object.getPrototypeOf(Pie)).apply(this, arguments));
	}

	_createClass(Pie, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(props) {
			return !imUtils.isEqual(props.state, this.props.state);
		}
	}, {
		key: 'render',
		value: function render() {
			var path = this.props.state.path;
			var labels = path.labels,
			    positions = path.positions,
			    pinRadius = path.pinRadius,
			    pinLength = path.pinLength,
			    pinHook = path.pinHook,
			    pinDraw = path.pinDraw,
			    pinFontSize = path.pinFontSize,
			    origin = path.origin,
			    radius = path.radius,
			    toreRadius = path.toreRadius;


			if (positions.length === 0) {
				return null;
			}

			var abs = function abs(ang, rad, or) {
				return rad * Math.cos(ang * Math.PI / 180) + or.x;
			};
			var coo = function coo(ang, rad, or) {
				return -rad * Math.sin(ang * Math.PI / 180) + or.y;
			};

			var oldT = 0;
			var out = [];
			var x = abs(oldT, radius, origin);
			var y = coo(oldT, radius, origin);

			for (var p = 0; p < positions.length; p++) {

				var color = positions[p].color;
				var theta = Math.min(positions[p].value, 359.9640); // more than 99.99% is a circle (not supported by arc anyway)
				var label = !!labels[p] ? labels[p] : null;
				var x1 = abs(oldT, toreRadius, origin);
				var y1 = coo(oldT, toreRadius, origin);
				var x2 = abs(oldT, radius, origin);
				var y2 = coo(oldT, radius, origin);
				var x3 = abs(theta + oldT, radius, origin);
				var y3 = coo(theta + oldT, radius, origin);
				var x4 = abs(theta + oldT, toreRadius, origin);
				var y4 = coo(theta + oldT, toreRadius, origin);

				// large-arc-flag, true if theta > 180
				var laf = theta > 180 ? 1 : 0;
				var _path = 'M' + x1 + ',' + y1 + ' L' + x2 + ',' + y2 + ' A' + radius + ',' + radius + ' 0 ' + laf + ',0 ' + x3 + ',' + y3 + ' L ' + x4 + ',' + y4 + ' A' + toreRadius + ',' + toreRadius + ' 0 ' + laf + ',1 ' + x1 + ',' + y1;

				out.push(React.createElement('path', { key: p, fill: color, stroke: 'none', strokeWidth: '0', d: _path }));

				if (!!label) {
					var curAng = theta / 2 + oldT;
					var offset = curAng === 90 || curAng === 270 ? 0 : curAng > 90 && curAng < 270 ? -pinHook : pinHook;
					var xc1 = abs(curAng, pinRadius, origin);
					var yc1 = coo(curAng, pinRadius, origin);
					var xc2 = abs(curAng, pinRadius + pinLength, origin);
					var yc2 = coo(curAng, pinRadius + pinLength, origin);
					var xc3 = xc2 + offset;
					var yc3 = yc2;
					var xc = xc3 + offset / 2;
					var yc = yc2 + (curAng === 90 ? -5 : curAng === 270 ? 5 : 0);
					var lstyle = {
						textAnchor: curAng === 90 || curAng === 270 ? 'center' : curAng > 90 && curAng < 270 ? 'end' : 'start'
					};
					if (pinDraw) {
						var lpath = 'M' + xc1 + ',' + yc1 + ' L' + xc2 + ',' + yc2 + ' L' + xc3 + ',' + yc3;
						out.push(React.createElement('path', { key: p + '.ll', strokeWidth: '1', stroke: 'black', fill: 'none', d: lpath }));
					}
					out.push(React.createElement(
						'text',
						{ fontSize: pinFontSize, key: p + '.l', x: xc, y: yc, style: lstyle },
						label
					));
				}
				x = x2;
				y = y2;
				oldT += theta;
			}

			return React.createElement(
				'g',
				null,
				out
			);
		}
	}]);

	return Pie;
}(React.Component);

module.exports = Pie;