'use strict';

var React = require('react');
var Plain = require('./Plain.js');
var Stairs = require('./Stairs.js');
var BarChart = require('./BarChart.js');
var Pie = require('./Pie.js');

var utils = require('../core/utils.js');

// the graphs function generator
var graph = {};

graph.Plain = function (props) {
	return React.createElement(Plain, { key: props.key, state: props });
};

graph.Stairs = function (props) {
	return React.createElement(Stairs, { key: props.key, state: props });
};

graph.Bars = graph.yBars = function (props) {
	return React.createElement(BarChart, { key: props.key, state: props });
};

graph.Pie = function (props) {
	return React.createElement(Pie, { key: props.key, state: props });
};

var m = function m(key, props) {
	if (utils.isNil(graph[key])) {
		throw new Error('Unknown graph type "' + key + '"');
	}

	return graph[key](props);
};

module.exports = m;