'use strict';

var core = require('./core/process.js');
var utils = require('./core/utils.js');
var space = require('./core/space-transf.js');

var m = {};

m.init = function (rawProps, type) {

	var props = utils.deepCp({}, rawProps);
	props.freeze = type;

	var freezer = core.process(props);

	var rc = {};

	rc.props = function () {
		return freezer.get();
	};

	rc.mgr = function () {
		return freezer;
	};

	rc.toC = function (point) {
		return {
			x: space.toC(point.ds.x, point.position.x),
			y: space.toC(point.ds.y, point.position.y)
		};
	};

	rc.__preprocessed = true;

	rc.updateGraph = function (obj) {
		return freezer.on('update', function () {
			return obj.forceUpdate();
		});
	};

	return rc;
};

module.exports = m;