'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var dataScale = require('../core/space-transf.js');
var utils = require('../core/utils.js');
var imUtils = require('../core/im-utils.js');

/*
	{
		draw: false,
		ds: {
			x: {}, // see space-mgr for details
			y: {}
		}, // see space-mgr for details
		position:{
			x:0,
			y:0
		},
		drop:{
			x:null, 
			y:0
		},
		width: 0,
		span: 0.5,
		color: '',
		fill: '',
		shade: 1
	}
*/

var BarMark = function (_React$Component) {
	_inherits(BarMark, _React$Component);

	function BarMark() {
		_classCallCheck(this, BarMark);

		return _possibleConstructorReturn(this, (BarMark.__proto__ || Object.getPrototypeOf(BarMark)).apply(this, arguments));
	}

	_createClass(BarMark, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(props) {
			return !imUtils.isEqual(props.state, this.props.state);
		}
	}, {
		key: 'render',
		value: function render() {
			var state = this.props.state;


			var mgr = {
				x: utils.mgr(state.position.x),
				y: utils.mgr(state.position.y)
			};

			var ds = state.ds;

			var position = state.position;

			var span = {
				x: utils.isNil(state.span.x) ? 0 : state.span.x,
				y: utils.isNil(state.span.y) ? 0 : state.span.y
			};

			var drop = {
				x: utils.isNil(state.drop.x) ? state.position.x : state.drop.x,
				y: utils.isNil(state.drop.y) ? state.position.y : state.drop.y
			};

			var toC = function toC(dir) {
				var op = dir === 'y' ? 'add' : 'subtract';
				return dataScale.toC(ds[dir], mgr[dir][op](position[dir], mgr[dir].divide(span[dir], 2))); // all in dataSpace
			};

			var x = toC('x');
			var y = toC('y');

			var toCwidth = function toCwidth(dir) {
				return dataScale.toCwidth(ds[dir], mgr[dir].add(mgr[dir].distance(drop[dir], position[dir]), span[dir]));
			};

			var height = toCwidth('y');
			var width = toCwidth('x');
			if (mgr.y.lowerThan(position.y, drop.y)) {
				y -= height;
			}
			if (mgr.x.greaterThan(position.x, drop.x)) {
				x -= width;
			}

			var color = state.color || state.fill || 'none';
			var stroke = state.draw ? color : null;
			if (drop.y > state.y) {
				y -= height;
			}

			return React.createElement('rect', { x: x, y: y, height: height, width: width,
				stroke: stroke, strokeWidth: state.strokeWidth,
				fill: color, opacity: state.shade });
		}
	}]);

	return BarMark;
}(React.Component);

module.exports = BarMark;