'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var dataScale = require('../core/space-transf.js');
var imUtils = require('../core/im-utils.js');

/*
	{
		draw: true || false,
		ds: {
			x: {}, 
			y:{}
		},
		position: {
			x: 0,
			y: 0
		},
		radius: ,
		color: '',
		width: ,
		fill: ,
		size: ,
		shade: 1
	}
*/

var DotMark = function (_React$Component) {
	_inherits(DotMark, _React$Component);

	function DotMark() {
		_classCallCheck(this, DotMark);

		return _possibleConstructorReturn(this, (DotMark.__proto__ || Object.getPrototypeOf(DotMark)).apply(this, arguments));
	}

	_createClass(DotMark, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(props) {
			return !imUtils.isEqual(props.state, this.props.state);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props$state = this.props.state,
			    ds = _props$state.ds,
			    position = _props$state.position,
			    size = _props$state.size,
			    color = _props$state.color,
			    radius = _props$state.radius,
			    fill = _props$state.fill,
			    shade = _props$state.shade,
			    width = _props$state.width;


			var x = dataScale.toC(ds.x, position.x);
			var y = dataScale.toC(ds.y, position.y);
			var r = radius || size;
			var f = fill || color;

			return React.createElement('circle', { cx: x, cy: y, r: r, fill: f, opacity: shade, stroke: color, strokeWidth: width });
		}
	}]);

	return DotMark;
}(React.Component);

module.exports = DotMark;